import bge
import menu

status = None

def initiate(cont):
    '''Loads the next level with a dynamic loading bar'''
    global status
    
    level_file = get_level()
    status = bge.logic.LibLoad(level_file, 'Scene', load_actions=True, load_scripts=True, async=True)
    status.onFinish = finish_load

    cont.script = 'load.update'

def finish_load(status):
    '''
    Removes the loading bar, changes this script for one waiting for the end of the game.
    Also sets the scene camera.
    '''
    #Remove loading bar
    load_scene = [s for s in bge.logic.getSceneList() if s.name == 'Loading'][0]
    load_scene.end()

    #Set scene camera
    base_scene = [s for s in bge.logic.getSceneList() if s.name == 'Base'][0]
    base_scene.active_camera = base_scene.cameras[-1]

def update(cont):
    '''Sends messages with the body containing the percentage loaded'''
    progress = status.progress
    bge.logic.sendMessage('loading', str(progress))

def get_level():
    progress_path = bge.logic.expandPath('//progress.cfg')
    blend_path = bge.logic.expandPath('//levels/')
    blend_list = bge.logic.getBlendFileList('//levels/')
    
    current_progress = int(open(progress_path).read())
    try:
        next_blend = blend_list[current_progress]
    except:
        next_blend = blend_list[0]
        menu.reset_progress()
    return blend_path+next_blend
    

def text(cont):
    message_sens = cont.sensors['Message']
    print(message_sens.bodies)
    cont.owner.text = str(float(message_sens.bodies[0])*100)
